Index: npl/mailserver/netqmail/roberto-netqmail-1.06.patch-latest
===================================================================
--- npl/mailserver/netqmail/roberto-netqmail-1.06.patch-latest	(revision cd8630be6536b27ae1c762184795ee87723202ab)
+++ npl/mailserver/netqmail/roberto-netqmail-1.06.patch-latest	(revision 1ebb340be23e45ead361b729734f0e82007af6bd)
@@ -11064,19 +11441,18 @@
 +	if (!ParseTagValueList((char *) sValue.c_str(), tags, values))
 +		return DKIM_BAD_SYNTAX;
-+	// check signature version
++	/*- check signature version -*/
 +	if (values[0] != NULL) {
 +		if (strcmp(values[0], "1") == 0 || strcmp(values[0], "0.5") == 0 || strcmp(values[0], "0.4") == 0
 +			|| strcmp(values[0], "0.3") == 0 || strcmp(values[0], "0.2") == 0) {
 +			sig.Version = DKIM_SIG_VERSION_02_PLUS;
-+		} else {
-+		// unknown version
++		} else /*- unknown version -*/
 +			return DKIM_STAT_INCOMPAT;
-+		}
 +	} else {
-+		// Note:  DKIM Interop 1 pointed out that v= is now required, but we do
-+		// not enforce that in order to verify signatures made by older drafts.
-+
-+		// prior to 0.2, there MUST NOT have been a v=
-+		// (optionally) support these signatures, for backwards compatibility
++		/*-
++		 * Note:  DKIM Interop 1 pointed out that v= is now required, but we do
++		 * not enforce that in order to verify signatures made by older drafts.
++		 * prior to 0.2, there MUST NOT have been a v=
++		 * (optionally) support these signatures, for backwards compatibility
++		 */
 +		if (true) {
 +			sig.Version = DKIM_SIG_VERSION_PRE_02;
@@ -11085,27 +11461,26 @@
 +		}
 +	}
-+	// signature MUST have a=, b=, d=, h=, s=
++	/*- signature MUST have a=, b=, d=, h=, s= -*/
 +	if (values[1] == NULL || values[2] == NULL || values[3] == NULL || values[4] == NULL || values[5] == NULL)
 +		return DKIM_BAD_SYNTAX;
-+	// algorithm can be "rsa-sha1" or "rsa-sha256"
++	/*- algorithm can be "rsa-sha1" or "rsa-sha256" -*/
 +	if (strcmp(values[1], "rsa-sha1") == 0) {
 +		sig.m_nHash = DKIM_HASH_SHA1;
 +	}
 +#ifdef HAVE_EVP_SHA256
-+	else if (strcmp(values[1], "rsa-sha256") == 0) {
++	else
++	if (strcmp(values[1], "rsa-sha256") == 0)
 +		sig.m_nHash = DKIM_HASH_SHA256;
-+	}
 +#endif
-+	else {
-+		return DKIM_BAD_SYNTAX;	// todo: maybe create a new error code for unknown algorithm
-+	}
-+	// make sure the signature data is not empty
++	else
++		return DKIM_BAD_SYNTAX;	/* todo: maybe create a new error code for unknown algorithm */
++	/*- make sure the signature data is not empty -*/
 +	unsigned SigDataLen = DecodeBase64(values[2]);
 +	if (SigDataLen == 0)
 +		return DKIM_BAD_SYNTAX;
 +	sig.SignatureData.assign(values[2], SigDataLen);
-+	// check for body hash
++	/*- check for body hash -*/
 +	if (values[12] == NULL) {
-+		// use the old single hash way for backwards compatibility
++		/*- use the old single hash way for backwards compatibility -*/
 +		if (sig.Version != DKIM_SIG_VERSION_PRE_02)
 +			return DKIM_BAD_SYNTAX;
@@ -11116,24 +11491,23 @@
 +		sig.BodyHashData.assign(values[12], BodyHashLen);
 +	}
-+	// domain must not be empty
++	/*- domain must not be empty -*/
 +	if (*values[3] == '\0')
 +		return DKIM_BAD_SYNTAX;
 +	sig.Domain = values[3];
-+	// signed headers must not be empty (more verification is done later)
++	/*- signed headers must not be empty (more verification is done later) -*/
 +	if (*values[4] == '\0')
 +		return DKIM_BAD_SYNTAX;
-+	// selector must not be empty
++	/*- selector must not be empty -*/
 +	if (*values[5] == '\0')
 +		return DKIM_BAD_SYNTAX;
 +	sig.Selector = values[5];
-+	// canonicalization
++	/*- canonicalization -*/
 +	if (values[6] == NULL) {
 +		sig.HeaderCanonicalization = sig.BodyCanonicalization = DKIM_CANON_SIMPLE;
 +	}
 +	else
-+	if (sig.Version == DKIM_SIG_VERSION_PRE_02 && strcmp(values[6], "nowsp") == 0) {
-+	// for backwards compatibility
++	if (sig.Version == DKIM_SIG_VERSION_PRE_02 && strcmp(values[6], "nowsp") == 0) /*- for backwards compatibility -*/
 +		sig.HeaderCanonicalization = sig.BodyCanonicalization = DKIM_CANON_NOWSP;
-+	} else {
++	else {
 +		char           *slash = strchr(values[6], '/');
 +		if (slash != NULL)
@@ -11154,12 +11528,12 @@
 +			return DKIM_BAD_SYNTAX;
 +	}
-+	// identity
++	/*- identity -*/
 +	if (values[7] == NULL) {
 +		sig.IdentityLocalPart.erase();
 +		sig.IdentityDomain = sig.Domain;
 +	} else {
-+		// quoted-printable decode the value
++		/*- quoted-printable decode the value -*/
 +		DecodeQuotedPrintable(values[7]);
-+		// must have a '@' separating the local part from the domain
++		/*- must have a '@' separating the local part from the domain -*/
 +		char           *at = strchr(values[7], '@');
 +		if (at == NULL)
@@ -11168,9 +11542,9 @@
 +		char           *ilocalpart = values[7];
 +		char           *idomain = at + 1;
-+		// i= domain must be the same as or a subdomain of the d= domain
++		/*- i= domain must be the same as or a subdomain of the d= domain -*/
 +		int idomainlen = strlen(idomain);
 +		int ddomainlen = strlen(values[3]);
 +
-+		// todo: maybe create a new error code for invalid identity domain
++		/*- todo: maybe create a new error code for invalid identity domain -*/
 +		if (idomainlen < ddomainlen)
 +			return DKIM_BAD_SYNTAX;
@@ -11182,5 +11556,5 @@
 +		sig.IdentityDomain = idomain;
 +	}
-+	// body count
++	/*- body count -*/
 +	if (values[8] == NULL || !m_HonorBodyLengthTag) {
 +		sig.BodyLength = -1;
@@ -11189,8 +11563,8 @@
 +			return DKIM_BAD_SYNTAX;
 +	}
-+	// query methods
++	/*- query methods -*/
 +	if (values[9] != NULL) {
 +
-+		// make sure "dns" is in the list
++		/*- make sure "dns" is in the list -*/
 +		bool            HasDNS = false;
 +		char           *s = strtok_r(values[9], ":", &saveptr);
@@ -11205,11 +11579,15 @@
 +			return DKIM_BAD_SYNTAX;	// todo: maybe create a new error code for unknown query method
 +	}
-+	// signature time
++#if SIZEOF_TIME_T  == 8
++	/*- signature time -*/
 +	time_t          SignedTime = -1;
++#else
++	long long       SignedTime = -1;
++#endif
 +	if (values[10] != NULL) {
 +		if (!ParseUnsigned(values[10], (unsigned long *) &SignedTime))
 +			return DKIM_BAD_SYNTAX;
 +	}
-+	// expiration time
++	/*- expiration time -*/
 +	if (values[11] == NULL) {
 +		sig.ExpireTime = -1;
@@ -11218,16 +11596,26 @@
 +			return DKIM_BAD_SYNTAX;
 +		if (sig.ExpireTime != -1) {
-+			// the value of x= MUST be greater than the value of t= if both are present
++			/*- the value of x= MUST be greater than the value of t= if both are present -*/
++#if SIZEOF_TIME_T  == 8
 +			if (SignedTime != -1 && sig.ExpireTime <= SignedTime)
 +				return DKIM_BAD_SYNTAX;
-+			// todo: if possible, use the received date/time instead of the current time
++#else
++			if (SignedTime != -1 && (long long) sig.ExpireTime <= SignedTime)
++				return DKIM_BAD_SYNTAX;
++#endif
++			/*- todo: if possible, use the received date/time instead of the current time -*/
 +			time_t curtime = time(NULL);
++#if SIZEOF_TIME_T  == 8
 +			if (curtime > sig.ExpireTime)
 +				return DKIM_SIGNATURE_EXPIRED;
++#else /*- handle year 2038 the best we can, beyond which one has to upgrade to a 64 bit os */
++			if (curtime < 2147483648 && curtime > sig.ExpireTime)
++				return DKIM_SIGNATURE_EXPIRED;
++#endif
 +		}
 +	}
-+	// parse the signed headers list
++	/*- parse the signed headers list -*/
 +	bool            HasFrom = false, HasSubject = false;
-+	RemoveSWSP(values[4]);		// header names shouldn't have spaces in them so this should be ok...
++	RemoveSWSP(values[4]);		/*- header names shouldn't have spaces in them so this should be ok... */
 +	char           *s = strtok_r(values[4], ":", &saveptr);
 +	while (s != NULL) {
@@ -11241,12 +11629,12 @@
 +	}
 +	if (!HasFrom)
-+		return DKIM_BAD_SYNTAX;	// todo: maybe create a new error code for h= missing From
++		return DKIM_BAD_SYNTAX;	/*- todo: maybe create a new error code for h= missing From */
 +	if (m_SubjectIsRequired && !HasSubject)
-+		return DKIM_BAD_SYNTAX;	// todo: maybe create a new error code for h= missing Subject
++		return DKIM_BAD_SYNTAX;	/*- todo: maybe create a new error code for h= missing Subject */
 +	return DKIM_SUCCESS;
 +}
 +
 +
-+// ProcessBody - Process message body data
++/*- ProcessBody - Process message body data -*/
 +int
 +CDKIMVerify::ProcessBody(char *szBuffer, int nBufLength, bool bEOF)
@@ -11330,9 +11718,9 @@
 +		return DKIM_SELECTOR_INVALID;
 +	if (values[0] != NULL) {
-+
-+		// make sure the version is "DKIM1"
++		/*- make sure the version is "DKIM1" -*/
 +		if (strcmp(values[0], "DKIM1") != 0)
-+			return DKIM_SELECTOR_INVALID;	// todo: maybe create a new error code for unsupported selector version
-+		// make sure v= is the first tag in the response    // todo: maybe don't enforce this, it seems unnecessary
++			return DKIM_SELECTOR_INVALID;	/*- todo: maybe create a new error code for unsupported selector version */
++		/*- make sure v= is the first tag in the response  */
++		/*- todo: maybe don't enforce this, it seems unnecessary */
 +		for (unsigned int j = 1; j < sizeof (values) / sizeof (values[0]); j++) {
 +			if (values[j] != NULL && values[j] < values[0]) {
@@ -11341,8 +11729,8 @@
 +		}
 +	}
-+	// selector MUST have p= tag
++	/*- selector MUST have p= tag -*/
 +	if (values[4] == NULL)
 +		return DKIM_SELECTOR_INVALID;
-+	// granularity
++	/*- granularity -*/
 +	if (values[1] == NULL)
 +		Granularity = "*";
@@ -11350,5 +11738,5 @@
 +	else
 +		Granularity = values[1];
-+	// hash algorithm
++	/*- hash algorithm -*/
 +	if (values[2] == NULL) {
 +		AllowSHA1 = true;
@@ -11359,5 +11747,5 @@
 +#endif
 +	} else {
-+		// MUST include "sha1" or "sha256"
++		/*- MUST include "sha1" or "sha256" -*/
 +		char           *s = strtok_r(values[2], ":", &saveptr);
 +		while (s != NULL) {
@@ -11375,15 +11763,15 @@
 +		if (!AllowSHA1)
 +#endif
-+			return DKIM_SELECTOR_INVALID;	// todo: maybe create a new error code for unsupported hash algorithm
-+	}
-+	// key type
++			return DKIM_SELECTOR_INVALID;	/*- todo: maybe create a new error code for unsupported hash algorithm */
++	}
++	/*- key type -*/
 +	if (values[3] != NULL) {
-+		// key type MUST be "rsa"
++		/*- key type MUST be "rsa" -*/
 +		if (strcmp(values[3], "rsa") != 0)
 +			return DKIM_SELECTOR_INVALID;
 +	}
-+	// service type
++	/*- service type -*/
 +	if (values[5] != NULL) {
-+		// make sure "*" or "email" is in the list
++		/*- make sure "*" or "email" is in the list -*/
 +		bool            ServiceTypeMatch = false;
 +		char           *s = strtok_r(values[5], ":", &saveptr);
@@ -11398,5 +11786,5 @@
 +			return DKIM_SELECTOR_INVALID;
 +	}
-+	// flags
++	/*- flags -*/
 +	if (values[6] != NULL) {
 +		char           *s = strtok_r(values[6], ":", &saveptr);
@@ -11411,9 +11799,9 @@
 +		}
 +	}
-+#define M_ToConstUCharPtr(p)       reinterpret_cast<const unsigned char*>(p)          // Cast to unsigned char*
++#define M_ToConstUCharPtr(p)       reinterpret_cast<const unsigned char*>(p) /* Cast to unsigned char* */
 +	/*- public key data */
 +	unsigned        PublicKeyLen = DecodeBase64(values[4]);
 +	if (PublicKeyLen == 0)
-+		return DKIM_SELECTOR_KEY_REVOKED;	// this error causes the signature to fail
++		return DKIM_SELECTOR_KEY_REVOKED; /*- this error causes the signature to fail */
 +	else {
 +		EVP_PKEY       *pkey;
@@ -11447,9 +11835,8 @@
 +}
 +
-+// GetSelector - Get a DKIM selector for a domain
++/*- GetSelector - Get a DKIM selector for a domain -*/
 +SelectorInfo &CDKIMVerify::GetSelector(const string &sSelector, const string &sDomain)
 +{
-+
-+	// see if we already have this selector
++	/*- see if we already have this selector -*/
 +	for (list < SelectorInfo >::iterator i = Selectors.begin(); i != Selectors.end(); ++i) {
 +		if (_stricmp(i->Selector.c_str(), sSelector.c_str()) == 0 && _stricmp(i->Domain.c_str(), sDomain.c_str()) == 0) {
@@ -11462,5 +11849,5 @@
 +	sFQDN += "._domainkey.";
 +	sFQDN += sDomain;
-+	char            Buffer[1024];
++	char            Buffer[4096];
 +	int             DNSResult;
 +
@@ -11487,5 +11874,5 @@
 +}
 +
-+// GetDetails - Get DKIM verification details (per signature)
++/*- GetDetails - Get DKIM verification details (per signature) -*/
 +int
 +CDKIMVerify::GetDetails(int *nSigCount, DKIMVerifyDetails ** pDetails)
@@ -11508,8 +11895,8 @@
 +CDKIMVerify::GetDomain(void)
 +{
-+	string          sFromDomain;
++	static string   sFromDomain;
 +	for (list <string>::iterator i = HeaderList.begin(); i != HeaderList.end(); ++i) {
 +		if (_strnicmp(i->c_str(), "From", 4) == 0) {
-+			// skip over whitespace between the header name and :
++			/*- skip over whitespace between the header name and : -*/
 +			const char     *s = i->c_str() + 4;
 +			while (*s == ' ' || *s == '\t')
@@ -11531,5 +11918,5 @@
 +getversion_dkimverify_cpp()
 +{
-+	static char    *x = (char *) "$Id: dkimverify.cpp,v 1.18 2017-09-05 11:00:33+05:30 Cprogrammer Exp mbhangui $";
++	static char    *x = (char *) "$Id: dkimverify.cpp,v 1.23 2019-05-22 11:29:09+05:30 Cprogrammer Exp mbhangui $";
 +
 +	x++;
@@ -11537,8 +11924,14 @@
 diff -ruN ../netqmail-1.06-original/dkimverify.h netqmail-1.06/dkimverify.h
 --- ../netqmail-1.06-original/dkimverify.h	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/dkimverify.h	2018-04-03 14:46:51.367411617 +0200
-@@ -0,0 +1,139 @@
++++ netqmail-1.06/dkimverify.h	2019-06-19 09:47:30.665464671 +0200
+@@ -0,0 +1,150 @@
 +/*
 + * $Log: dkimverify.h,v $
++ * Revision 1.9  2019-06-14 21:25:11+05:30  Cprogrammer
++ * BUG - honor body length tag in verification. Changed data type for BodyLength
++ *
++ * Revision 1.8  2019-05-22 11:30:06+05:30  Cprogrammer
++ * fix for 32 bit systems where time_t is 4 bytes & encounters year 2038 issue
++ *
 + * Revision 1.7  2017-08-31 17:07:45+05:30  Cprogrammer
 + * fixed g++ compiler warning
@@ -11586,4 +11979,5 @@
 +
 +#include "dkimbase.h"
++#include "time_t_size.h"
 +#include <vector>
 +
@@ -11624,10 +12018,14 @@
 +	string          CanonicalizedData;
 +	vector <string> SignedHeaders;
-+	int             BodyLength;
++	long            BodyLength;
 +	unsigned        HeaderCanonicalization;
 +	unsigned        BodyCanonicalization;
++#if SIZEOF_TIME_T  == 8
 +	time_t          ExpireTime;
-+	int             VerifiedBodyCount;
-+	unsigned        UnverifiedBodyCount;
++#else
++	long long       ExpireTime;
++#endif
++	long            VerifiedBodyCount;
++	long            UnverifiedBodyCount;
 +#if OPENSSL_VERSION_NUMBER >= 0x10100000L
 +	EVP_MD_CTX     *m_Hdr_ctx = NULL;
@@ -11680,5 +12078,5 @@
 diff -ruN ../netqmail-1.06-original/dknewkey.sh netqmail-1.06/dknewkey.sh
 --- ../netqmail-1.06-original/dknewkey.sh	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/dknewkey.sh	2016-11-22 21:03:57.112528099 +0100
++++ netqmail-1.06/dknewkey.sh	2019-02-27 20:57:13.389025081 +0100
 @@ -0,0 +1,27 @@
 +#
@@ -11711,5 +12109,5 @@
 diff -ruN ../netqmail-1.06-original/dktest.9 netqmail-1.06/dktest.9
 --- ../netqmail-1.06-original/dktest.9	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/dktest.9	2016-11-22 21:03:57.112528099 +0100
++++ netqmail-1.06/dktest.9	2019-02-27 20:57:13.389025081 +0100
 @@ -0,0 +1,86 @@
 +.TH dktest 8
@@ -11801,6 +12199,6 @@
 diff -ruN ../netqmail-1.06-original/dktest.c netqmail-1.06/dktest.c
 --- ../netqmail-1.06-original/dktest.c	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/dktest.c	2016-11-22 21:03:57.112528099 +0100
-@@ -0,0 +1,431 @@
++++ netqmail-1.06/dktest.c	2020-04-09 19:44:51.053935329 +0200
+@@ -0,0 +1,434 @@
 +/*
 + * $Log: dktest.c,v $
@@ -12204,4 +12602,7 @@
 +			status = "bad sender (g=)";
 +			break;
++		case DK_STAT_DUPLICATE:
++			status = "duplicate signature";
++			break;
 +		}
 +#if 0
@@ -12236,5 +12637,5 @@
 diff -ruN ../netqmail-1.06-original/dktrace.c netqmail-1.06/dktrace.c
 --- ../netqmail-1.06-original/dktrace.c	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/dktrace.c	2016-11-22 21:03:57.112528099 +0100
++++ netqmail-1.06/dktrace.c	2019-02-27 20:57:13.389025081 +0100
 @@ -0,0 +1,277 @@
 +/*
@@ -12517,5 +12918,5 @@
 diff -ruN ../netqmail-1.06-original/dktrace.h netqmail-1.06/dktrace.h
 --- ../netqmail-1.06-original/dktrace.h	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/dktrace.h	2016-11-22 21:03:57.112528099 +0100
++++ netqmail-1.06/dktrace.h	2019-02-27 20:57:13.389025081 +0100
 @@ -0,0 +1,26 @@
 +/* $Id: dktrace.h,v 1.3 2005/06/27 18:47:57 ted46045 Exp $ */
@@ -12547,5 +12948,5 @@
 diff -ruN ../netqmail-1.06-original/dns.c netqmail-1.06/dns.c
 --- ../netqmail-1.06-original/dns.c	2007-11-30 21:22:54.000000000 +0100
-+++ netqmail-1.06/dns.c	2018-04-02 11:45:03.323768372 +0200
++++ netqmail-1.06/dns.c	2019-04-09 20:53:51.981528338 +0200
 @@ -1,4 +1,3 @@
 -#include <stdio.h>
@@ -12710,5 +13111,5 @@
     case DNS_MEM: return DNS_MEM;
     case DNS_SOFT: return DNS_SOFT;
-@@ -254,25 +318,46 @@
+@@ -254,25 +318,49 @@
     if (r == DNS_SOFT) return DNS_SOFT;
     if (r == 1)
@@ -12757,9 +13158,11 @@
   if (!stralloc_0(&glue)) return DNS_MEM;
   if (glue.s[0]) {
--   ix.pref = 0;
++#ifndef IX_FQDN
+    ix.pref = 0;
++#endif
     if (!glue.s[ip_scan(glue.s,&ix.ip)] || !glue.s[ip_scanbracket(glue.s,&ix.ip)])
      {
       if (!ipalloc_append(ia,&ix)) return DNS_MEM;
-@@ -291,9 +376,16 @@
+@@ -291,9 +379,16 @@
     ix.ip = ip;
     ix.pref = pref;
@@ -12779,5 +13182,5 @@
  }
  
-@@ -313,7 +405,7 @@
+@@ -313,7 +408,7 @@
  {
   int r;
@@ -12788,13 +13191,15 @@
   int i;
   int j;
-@@ -325,7 +417,6 @@
+@@ -325,7 +420,9 @@
   if (!stralloc_copy(&glue,sa)) return DNS_MEM;
   if (!stralloc_0(&glue)) return DNS_MEM;
   if (glue.s[0]) {
--   ix.pref = 0;
++#ifndef IX_FQDN
+    ix.pref = 0;
++#endif
     if (!glue.s[ip_scan(glue.s,&ix.ip)] || !glue.s[ip_scanbracket(glue.s,&ix.ip)])
      {
       if (!ipalloc_append(ia,&ix)) return DNS_MEM;
-@@ -396,3 +487,49 @@
+@@ -396,3 +493,49 @@
   alloc_free(mx);
   return flagsoft;
@@ -12848,5 +13253,5 @@
 diff -ruN ../netqmail-1.06-original/dns.h netqmail-1.06/dns.h
 --- ../netqmail-1.06-original/dns.h	1998-06-15 12:53:16.000000000 +0200
-+++ netqmail-1.06/dns.h	2016-11-22 21:03:57.113528065 +0100
++++ netqmail-1.06/dns.h	2019-02-27 20:57:13.390025070 +0100
 @@ -10,5 +10,6 @@
  int dns_mxip();
@@ -12858,5 +13263,5 @@
 diff -ruN ../netqmail-1.06-original/dnsfq.c netqmail-1.06/dnsfq.c
 --- ../netqmail-1.06-original/dnsfq.c	1998-06-15 12:53:16.000000000 +0200
-+++ netqmail-1.06/dnsfq.c	2016-11-22 21:03:57.113528065 +0100
++++ netqmail-1.06/dnsfq.c	2019-02-27 20:57:13.390025070 +0100
 @@ -5,15 +5,19 @@
  #include "dnsdoe.h"
@@ -12896,5 +13301,5 @@
 diff -ruN ../netqmail-1.06-original/dnsptr.c netqmail-1.06/dnsptr.c
 --- ../netqmail-1.06-original/dnsptr.c	1998-06-15 12:53:16.000000000 +0200
-+++ netqmail-1.06/dnsptr.c	2016-11-22 21:03:57.113528065 +0100
++++ netqmail-1.06/dnsptr.c	2019-02-27 20:57:13.390025070 +0100
 @@ -6,22 +6,28 @@
  #include "dns.h"
@@ -12932,5 +13337,5 @@
 diff -ruN ../netqmail-1.06-original/dnstxt.c netqmail-1.06/dnstxt.c
 --- ../netqmail-1.06-original/dnstxt.c	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/dnstxt.c	2016-11-22 21:03:57.113528065 +0100
++++ netqmail-1.06/dnstxt.c	2019-02-27 20:57:13.390025070 +0100
 @@ -0,0 +1,32 @@
 +#include "substdio.h"
@@ -12968,6 +13373,6 @@
 diff -ruN ../netqmail-1.06-original/domainkeys.h netqmail-1.06/domainkeys.h
 --- ../netqmail-1.06-original/domainkeys.h	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/domainkeys.h	2018-03-31 15:08:54.373109416 +0200
-@@ -0,0 +1,378 @@
++++ netqmail-1.06/domainkeys.h	2020-04-09 19:45:10.589742433 +0200
+@@ -0,0 +1,379 @@
 +/* This file is automatically created from the corresponding .c file */
 +/* Do not change this file; change the .c file instead. */
@@ -13037,4 +13442,5 @@
 +  DK_STAT_INTERNAL, /* cannot call this routine in this context.  Internal error. */
 +  DK_STAT_GRANULARITY, /* Granularity mismatch: sender doesn't match g= option. */
++  DK_STAT_DUPLICATE, /* Duplicate Domainkey-Header */
 +} DK_STAT;
 +
@@ -13350,5 +13756,5 @@
 diff -ruN ../netqmail-1.06-original/forward.c netqmail-1.06/forward.c
 --- ../netqmail-1.06-original/forward.c	1998-06-15 12:53:16.000000000 +0200
-+++ netqmail-1.06/forward.c	2016-11-22 21:03:57.114528032 +0100
++++ netqmail-1.06/forward.c	2019-02-27 20:57:13.391025058 +0100
 @@ -6,11 +6,11 @@
  #include "strerr.h"
@@ -13384,5 +13790,5 @@
 diff -ruN ../netqmail-1.06-original/global.h netqmail-1.06/global.h
 --- ../netqmail-1.06-original/global.h	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/global.h	2016-11-22 21:03:57.114528032 +0100
++++ netqmail-1.06/global.h	2019-02-27 20:57:13.391025058 +0100
 @@ -0,0 +1,51 @@
 +/* GLOBAL.H - RSAREF types and constants */
